#if !defined(AFX_MECHTHREAD_H__3C2A5948_7E2D_4E82_891B_EA425236B1FC__INCLUDED_)
#define AFX_MECHTHREAD_H__3C2A5948_7E2D_4E82_891B_EA425236B1FC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MechThread.h : header file
//

#define MECH_TIMEOUT 2

#define STATE_SECURITY 0
#define STATE_READAUDIT 1
#define STATE_AUDITDONE 2

#define STATE_READTRANS 2
#define STATE_TRANSDONE 3

#include "Comm.h"
#include "Audit.h"
#include "Trans.h"

class CMeterCommDlg; // forward definition to avoid include loop

/////////////////////////////////////////////////////////////////////////////
// CMechThread thread

class CMechThread : public CWinThread
{
	DECLARE_DYNCREATE(CMechThread)
protected:
	CMechThread();           // protected constructor used by dynamic creation

// Attributes
public:

	CMechThread(CComm *com);


// Operations
public:


	CComm *m_pComm;
	CMeterCommDlg *m_pDlg;
	CAudit *m_pAudit;
	CTrans *m_pTrans;

	BOOL m_bSuccess;

	BOOL StartFunction(int iFunc);
	BOOL StopFunction();
	BOOL NotifyText(CString *Text);
	BOOL NotifySetRange(int iLow, int iHigh);
	BOOL NotifySetPos(int iPos);
	BOOL NotifyStep();
	BOOL Notify(CString *text);

	int OnIdle(LONG lCount);

	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMechThread)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMechThread();

	BOOL DisableSecurity(BOOL bStep);
	BOOL ReadAudit(BOOL bStep);
	BOOL SaveAudit();
	BOOL SaveTrans();
	BOOL ReadTrans(BOOL b8KMech);
	BOOL ReadRam(int iPage, int iByte, int iLen);

	int CalcValue(unsigned char *c_pPtr, int iLen);
	int iFunction;
	BOOL bAlive;
	int iState;
	int iStep;
	
	/* trnas stuff */
	unsigned char cData[256];
	int iLocationPtr;
	int iPageNum;
	int iStopPage;
	int iStopLocation;
	int iEndPage;
	int iEndLocation;
	int iAddTransCntr;
	int iLastTransNum;
	int iTransPage; /* giDbasePage in duncan's code */
	int iTransNum;  /* giTransNum in duncan's code */
	int ilTransNum; 
	BOOL bOverflow;


	// Generated message map functions
	//{{AFX_MSG(CMechThread)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MECHTHREAD_H__3C2A5948_7E2D_4E82_891B_EA425236B1FC__INCLUDED_)
